-
AI-powered Extensions
-
Data Grid
-
Tree List
-
Chat
-
HTML Editor
-
Form
-
-
Data Grids / Data Management
-
Data Grid
- Overview
-
Data Binding
-
Filtering
- Sorting
-
Editing
-
Grouping
-
Selection
- Focused Row
- Paging
-
Scrolling
-
Columns
- AI Assistant
-
Master-Detail
-
Data Summaries
-
Drag & Drop
-
Export to PDF
-
Export to Excel
- Appearance
-
Customization
- State Persistence
-
Adaptability
-
Keyboard Navigation
- Right-To-Left Support
-
Tree List
- Overview
-
Data Binding
-
Filtering
- Sorting
-
Editing
-
Selection
- Focused Row
- Paging
-
Columns
- Drag & Drop
- State Persistence
- Adaptability
-
Keyboard Navigation
-
Card View
-
Pivot Grid
- Overview
-
Data Binding
-
Field Management
-
Data Summaries
- Drill Down
- Filtering
-
Scrolling
-
Export to Excel
- Chart Integration
- Customization
- State Persistence
-
Filter Builder
-
-
Data Visualization
-
Charts
- Overview
-
Data Binding
-
Common Concepts
-
Axis
-
Aggregation
-
Tooltips
-
Selection
-
Customization
-
Zooming
-
Export
-
-
Area Charts
-
Bar Charts
- Bullet Charts
-
Doughnut Charts
-
Financial Charts
-
Funnel and Pyramid Charts
-
Line Charts
- Pareto Chart
-
Pie Charts
-
Point Charts
-
Polar and Radar Charts
-
Range Charts
- Sankey Chart
-
Sparkline Charts
-
Tree Map
-
Gauges
- Overview
-
Runtime update
-
Bar Gauge
-
Circular Gauge
-
Linear Gauge
-
Diagram
- Overview
-
Data Binding
-
Featured Shapes
-
Custom Shapes
-
Document Capabilities
-
User Interaction
- UI Customization
- Adaptability
-
-
Scheduling / Planning
-
Scheduler
- Overview
-
Data Binding
-
Views
-
Appointments
-
Timetable
- Editing
-
Grouping
- Virtual Scrolling
- Drag & Drop
-
Customization
- Adaptability
-
Gantt
- Overview
- Data Binding
-
Filtering
- Sorting
- Strip Lines
- Export to PDF
- Validation
-
Customization
-
-
Messaging
-
WYSIWYG Editor
-
Forms
-
Data Editors
- Overview
-
Common Concepts
-
Calendar
- Check Box
- Color Box
-
Date Box
-
Date Range Box
-
Number Box
- Radio Group
-
Range Selector
- Range Slider
- Slider
- Switch
- Text Area
- Text Box
-
Drop-Downs
- Autocomplete
-
Drop Down Box
-
Select Box
-
Tag Box
-
Lookup
-
Buttons
-
File Upload / File Management
-
File Manager
- Overview
-
File System Types
-
Customization
-
File Uploader
-
-
Popup and Notifications
-
Navigation
- Overview
- Accordion
-
Action Sheet
-
Context Menu
-
Menu
- Multi View
-
Drawer
-
Tab Panel
-
Tabs
-
Toolbar
-
Stepper
- Pagination
-
List
-
Tree View
- Right-to-Left Support
-
Layout
-
Interactive Wrappers
-
Sortable
- Resizable
-
-
Progress Indicators
-
Maps
- Overview
-
Map
-
Vector Map
-
Data Binding
- Multiple Layers
-
Markers
- Legend
-
Zooming and Panning
-
Customization
-
-
Localization
Related Demos:
Your search did not match any results.
JavaScript/jQuery Vector Map - Pie Markers
This demo shows how to use markers of the «pie» type in the JavaScript VectorMap. Values for pie markers are provided by the data field whose name is assigned to the dataField property.
Backend API
$(() => {
$('#vector-map').dxVectorMap({
layers: [{
dataSource: DevExpress.viz.map.sources.world,
hoverEnabled: false,
}, {
name: 'pies',
dataSource: markers,
elementType: 'pie',
dataField: 'values',
}],
tooltip: {
enabled: true,
customizeTooltip(arg) {
if (arg.layer.type === 'marker') {
return { text: arg.attribute('tooltip') };
}
return null;
},
},
legends: [{
source: { layer: 'pies', grouping: 'color' },
customizeText(arg) {
return names[arg.index];
},
}],
bounds: [-180, 85, 180, -60],
});
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<script src="js/dx.all.js?v=26.1.4"></script>
<script src="https://cdn3.devexpress.com/jslib/26.1.4/js/vectormap-data/world.js"></script>
<script src="https://cdn3.devexpress.com/jslib/26.1.4/js/vectormap-data/africa.js"></script>
<script src="https://cdn3.devexpress.com/jslib/26.1.4/js/vectormap-data/canada.js"></script>
<script src="https://cdn3.devexpress.com/jslib/26.1.4/js/vectormap-data/eurasia.js"></script>
<script src="https://cdn3.devexpress.com/jslib/26.1.4/js/vectormap-data/europe.js"></script>
<script src="https://cdn3.devexpress.com/jslib/26.1.4/js/vectormap-data/usa.js"></script>
<script src="data.js"></script>
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="index.js"></script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="vector-map"></div>
</div>
</body>
</html>
#vector-map {
height: 440px;
}
.country {
font-size: 15px;
font-weight: 500;
}
const names = ['Christian', 'Muslim', 'Unaffiliated', 'Buddhist', 'Jewish'];
const markers = {
type: 'FeatureCollection',
features: $.map([
{
coordinates: [34.6, -5.1],
values: [61.4, 35.2, 1.4, 0, 0],
country: 'Tanzania',
},
{
coordinates: [18.8, 15],
values: [40.6, 55.3, 2.5, 0, 0],
country: 'Chad',
},
{
coordinates: [7.36, 9.97],
values: [49.3, 48.8, 0.4, 0, 0],
country: 'Nigeria',
},
{
coordinates: [135.61, -24.57],
values: [67.3, 2.4, 24.2, 2.7, 0.5],
country: 'Australia',
},
{
coordinates: [103.3, 34.85],
values: [5.1, 1.8, 52.2, 18.2, 0],
country: 'China',
},
{
coordinates: [139.5, 37],
values: [1.6, 0.2, 57, 36.2, 0],
country: 'Japan',
},
{
coordinates: [100.8, 15.9],
values: [0.9, 5.5, 0.3, 93.2, 0],
country: 'Thailand',
},
{
coordinates: [10.4, 51.4],
values: [68.7, 5.8, 24.7, 0.3, 0.3],
country: 'Germany',
},
{
coordinates: [100.8, 65.3],
values: [73.3, 10, 16.2, 0.1, 0.2],
country: 'Russia',
},
{
coordinates: [-3.48, 40.36],
values: [78.6, 2.1, 19, 0, 0.1],
country: 'Spain',
},
{
coordinates: [-78.01, 21.72],
values: [59.2, 0, 23, 0, 0],
country: 'Cuba',
},
{
coordinates: [-63.7, -31.92],
values: [85.2, 1, 12.2, 0.05, 0.5],
country: 'Argentina',
},
{
coordinates: [-110.53, 60.78],
values: [69, 2.1, 23.7, 0.5, 0.3],
country: 'Canada',
},
{
coordinates: [-100.1, 40.14],
values: [78.3, 0.9, 16.4, 1.2, 1.8],
country: 'United States',
},
{
coordinates: [34.88, 31.16],
values: [2, 18.6, 3.1, 0.3, 75.6],
country: 'Israel',
},
], (data) => {
const list = [`<span class='country'>${data.country}</span>`, ' '];
$.each(data.values, (i, value) => {
if (value > 0) {
list.push(`${names[i]}: ${value}%`);
}
});
return {
type: 'Feature',
geometry: {
type: 'Point',
coordinates: data.coordinates,
},
properties: {
tooltip: list.join('\n'),
values: data.values,
},
};
}),
};

Backend API
<dx-vector-map id="vector-map" [bounds]="[-180, 85, 180, -60]">
<dxo-vector-map-tooltip
[enabled]="true"
[customizeTooltip]="customizeTooltip"
></dxo-vector-map-tooltip>
<dxi-vector-map-layer
[dataSource]="worldMap"
[hoverEnabled]="false"
></dxi-vector-map-layer>
<dxi-vector-map-layer
[dataSource]="markers"
name="pies"
elementType="pie"
dataField="values"
></dxi-vector-map-layer>
<dxi-vector-map-legend [customizeText]="customizeText">
<dxo-vector-map-source
layer="pies"
grouping="color"
></dxo-vector-map-source>
</dxi-vector-map-legend>
</dx-vector-map>
import { bootstrapApplication } from '@angular/platform-browser';
import { Component, enableProdMode, provideZoneChangeDetection } from '@angular/core';
import { DxVectorMapModule } from 'devextreme-angular';
import * as mapsData from 'devextreme-dist/js/vectormap-data/world.js';
import { FeatureCollection, Service } from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
providers: [Service],
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
imports: [
DxVectorMapModule,
],
})
export class AppComponent {
worldMap = mapsData.world;
markers: FeatureCollection;
names: string[];
constructor(service: Service) {
this.markers = service.getMarkers();
this.names = service.getNames();
this.customizeText = this.customizeText.bind(this);
}
customizeText = ({ index }: { index: number }) => this.names[index];
customizeTooltip = ({ layer, attribute }: { layer: Record<string, string>, attribute: Function }) => ((layer.type === 'marker')
? { text: attribute('tooltip') }
: undefined);
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
],
});
::ng-deep #vector-map {
height: 440px;
}
::ng-deep .country {
font-size: 15px;
font-weight: 500;
}
import { Injectable } from '@angular/core';
export class FeatureCollection {
type: string;
features: Feature[];
}
export class Feature {
type: string;
properties: FeatureProperty;
geometry: FeatureGeometry;
}
export class FeatureProperty {
values: number[];
tooltip: string;
}
export class FeatureGeometry {
type: string;
coordinates: number[];
}
const names: string[] = ['Christian', 'Muslim', 'Unaffiliated', 'Buddhist', 'Jewish'];
const markers: FeatureCollection = {
type: 'FeatureCollection',
features: [{
coordinates: [34.6, -5.1],
values: [61.4, 35.2, 1.4, 0, 0],
country: 'Tanzania',
}, {
coordinates: [18.8, 15],
values: [40.6, 55.3, 2.5, 0, 0],
country: 'Chad',
}, {
coordinates: [7.36, 9.97],
values: [49.3, 48.8, 0.4, 0, 0],
country: 'Nigeria',
}, {
coordinates: [135.61, -24.57],
values: [67.3, 2.4, 24.2, 2.7, 0.5],
country: 'Australia',
}, {
coordinates: [103.3, 34.85],
values: [5.1, 1.8, 52.2, 18.2, 0],
country: 'China',
}, {
coordinates: [139.5, 37],
values: [1.6, 0.2, 57, 36.2, 0],
country: 'Japan',
}, {
coordinates: [100.8, 15.9],
values: [0.9, 5.5, 0.3, 93.2, 0],
country: 'Thailand',
}, {
coordinates: [10.4, 51.4],
values: [68.7, 5.8, 24.7, 0.3, 0.3],
country: 'Germany',
}, {
coordinates: [100.8, 65.3],
values: [73.3, 10, 16.2, 0.1, 0.2],
country: 'Russia',
}, {
coordinates: [-3.48, 40.36],
values: [78.6, 2.1, 19, 0, 0.1],
country: 'Spain',
}, {
coordinates: [-78.01, 21.72],
values: [59.2, 0, 23, 0, 0],
country: 'Cuba',
}, {
coordinates: [-63.7, -31.92],
values: [85.2, 1, 12.2, 0.05, 0.5],
country: 'Argentina',
}, {
coordinates: [-110.53, 60.78],
values: [69, 2.1, 23.7, 0.5, 0.3],
country: 'Canada',
}, {
coordinates: [-100.1, 40.14],
values: [78.3, 0.9, 16.4, 1.2, 1.8],
country: 'United States',
}, {
coordinates: [34.88, 31.16],
values: [2, 18.6, 3.1, 0.3, 75.6],
country: 'Israel',
}].map((data) => {
const list = [`<span class='country'>${data.country}</span>`, ' '];
data.values.forEach((value, i) => {
if (value > 0) {
list.push(`${names[i]}: ${value}%`);
}
});
return {
type: 'Feature',
geometry: {
type: 'Point',
coordinates: data.coordinates,
},
properties: {
tooltip: list.join('\n'),
values: data.values,
},
};
}),
};
@Injectable()
export class Service {
getMarkers(): FeatureCollection {
return markers;
}
getNames(): string[] {
return names;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'devextreme-dist/js/vectormap-data/*': {
'esModule': true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'devextreme-dist/js/vectormap-data': '../../../../js/vectormap-data',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.4/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.16.2/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.29/package.json',
'npm:devexpress-gantt@4.1.69/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
},
"@angular/core": {
"version": "22.1.0"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "6.0.3"
},
"zone.js": {
"version": "0.16.2"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.16.2/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>

-
AI-powered Extensions
-
Data Grid
-
Tree List
-
Chat
-
HTML Editor
-
Form
-
-
Data Grids / Data Management
-
Data Grid
- Overview
-
Data Binding
-
Filtering
- Sorting
-
Editing
-
Grouping
-
Selection
- Focused Row
- Paging
-
Scrolling
-
Columns
- AI Assistant
-
Master-Detail
-
Data Summaries
-
Drag & Drop
-
Export to PDF
-
Export to Excel
- Appearance
-
Customization
- State Persistence
-
Adaptability
-
Keyboard Navigation
- Right-To-Left Support
-
Tree List
- Overview
-
Data Binding
-
Filtering
- Sorting
-
Editing
-
Selection
- Focused Row
- Paging
-
Columns
- Drag & Drop
- State Persistence
- Adaptability
-
Keyboard Navigation
-
Card View
-
Pivot Grid
- Overview
-
Data Binding
-
Field Management
-
Data Summaries
- Drill Down
- Filtering
-
Scrolling
-
Export to Excel
- Chart Integration
- Customization
- State Persistence
-
Filter Builder
-
-
Data Visualization
-
Charts
- Overview
-
Data Binding
-
Common Concepts
-
Axis
-
Aggregation
-
Tooltips
-
Selection
-
Customization
-
Zooming
-
Export
-
-
Area Charts
-
Bar Charts
- Bullet Charts
-
Doughnut Charts
-
Financial Charts
-
Funnel and Pyramid Charts
-
Line Charts
- Pareto Chart
-
Pie Charts
-
Point Charts
-
Polar and Radar Charts
-
Range Charts
- Sankey Chart
-
Sparkline Charts
-
Tree Map
-
Gauges
- Overview
-
Runtime update
-
Bar Gauge
-
Circular Gauge
-
Linear Gauge
-
Diagram
- Overview
-
Data Binding
-
Featured Shapes
-
Custom Shapes
-
Document Capabilities
-
User Interaction
- UI Customization
- Adaptability
-
-
Scheduling / Planning
-
Scheduler
- Overview
-
Data Binding
-
Views
-
Appointments
-
Timetable
- Editing
-
Grouping
- Virtual Scrolling
- Drag & Drop
-
Customization
- Adaptability
-
Gantt
- Overview
- Data Binding
-
Filtering
- Sorting
- Strip Lines
- Export to PDF
- Validation
-
Customization
-
-
Messaging
-
WYSIWYG Editor
-
Forms
-
Data Editors
- Overview
-
Common Concepts
-
Calendar
- Check Box
- Color Box
-
Date Box
-
Date Range Box
-
Number Box
- Radio Group
-
Range Selector
- Range Slider
- Slider
- Switch
- Text Area
- Text Box
-
Drop-Downs
- Autocomplete
-
Drop Down Box
-
Select Box
-
Tag Box
-
Lookup
-
Buttons
-
File Upload / File Management
-
File Manager
- Overview
-
File System Types
-
Customization
-
File Uploader
-
-
Popup and Notifications
-
Navigation
- Overview
- Accordion
-
Action Sheet
-
Context Menu
-
Menu
- Multi View
-
Drawer
-
Tab Panel
-
Tabs
-
Toolbar
-
Stepper
- Pagination
-
List
-
Tree View
- Right-to-Left Support
-
Layout
-
Tile View
- Splitter
-
Gallery
- Scroll View
- Box
- Responsive Box
-
-
Interactive Wrappers
-
Sortable
- Resizable
-
-
Progress Indicators
-
Maps
- Overview
-
Map
-
Vector Map
-
Data Binding
- Multiple Layers
-
Markers
- Legend
-
Zooming and Panning
-
Customization
-
-
Localization
Related Demos:
Your search did not match any results.
Vue Vector Map - Pie Markers
This demo shows how to use markers of the «pie» type in the VectorMap. Values for pie markers are provided by the data field whose name is assigned to the dataField property.
Backend API
<template>
<DxVectorMap
id="vector-map"
:bounds="bounds"
>
<DxLayer
:data-source="mapsWorld"
:hover-enabled="false"
/>
<DxLayer
:data-source="markers"
name="pies"
element-type="pie"
data-field="values"
/>
<DxLegend
:customize-text="customizeText"
>
<DxSource
layer="pies"
grouping="color"
/>
</DxLegend>
<DxTooltip
:enabled="true"
:customize-tooltip="customizeTooltip"
/>
</DxVectorMap>
</template>
<script setup lang="ts">
// @ts-ignore
import * as mapsData from 'devextreme-dist/js/vectormap-data/world.js';
import {
DxVectorMap,
DxLayer,
DxLegend,
DxSource,
DxTooltip,
} from 'devextreme-vue/vector-map';
import { markers, names } from './data.ts';
const mapsWorld = mapsData.world;
const bounds = [-180, 85, 180, -60];
const customizeTooltip = (info: any) => ((info.layer.type === 'marker') ? { text: info.attribute('tooltip') } : {});
const customizeText = ({ index }: Record<string, any> & { index: number }) => names[index];
</script>
<style>
#vector-map {
height: 440px;
}
</style>
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'typescript': {
'exports': 'ts',
},
'vue': {
format: 'global',
exports: 'Vue',
esModule: true,
},
'vuex': {
format: 'global',
exports: 'Vuex',
esModule: true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'devextreme-dist/js/vectormap-data/*': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'vue': 'npm:vue@3.5.40/dist/vue.global.js',
'@vue/shared': 'npm:@vue/shared@3.4.26/dist/shared.cjs.prod.js',
'dx-systemjs-vue-browser': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'vue-loader': 'loaders:demo-vue-loader.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'devextreme-dist/js/vectormap-data': '../../../../js/vectormap-data',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.4/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
export const names = ['Christian', 'Muslim', 'Unaffiliated', 'Buddhist', 'Jewish'];
export const markers = {
type: 'FeatureCollection',
features: [{
coordinates: [34.6, -5.1],
values: [61.4, 35.2, 1.4, 0, 0],
country: 'Tanzania',
}, {
coordinates: [18.8, 15],
values: [40.6, 55.3, 2.5, 0, 0],
country: 'Chad',
}, {
coordinates: [7.36, 9.97],
values: [49.3, 48.8, 0.4, 0, 0],
country: 'Nigeria',
}, {
coordinates: [135.61, -24.57],
values: [67.3, 2.4, 24.2, 2.7, 0.5],
country: 'Australia',
}, {
coordinates: [103.3, 34.85],
values: [5.1, 1.8, 52.2, 18.2, 0],
country: 'China',
}, {
coordinates: [139.5, 37],
values: [1.6, 0.2, 57, 36.2, 0],
country: 'Japan',
}, {
coordinates: [100.8, 15.9],
values: [0.9, 5.5, 0.3, 93.2, 0],
country: 'Thailand',
}, {
coordinates: [10.4, 51.4],
values: [68.7, 5.8, 24.7, 0.3, 0.3],
country: 'Germany',
}, {
coordinates: [100.8, 65.3],
values: [73.3, 10, 16.2, 0.1, 0.2],
country: 'Russia',
}, {
coordinates: [-3.48, 40.36],
values: [78.6, 2.1, 19, 0, 0.1],
country: 'Spain',
}, {
coordinates: [-78.01, 21.72],
values: [59.2, 0, 23, 0, 0],
country: 'Cuba',
}, {
coordinates: [-63.7, -31.92],
values: [85.2, 1, 12.2, 0.05, 0.5],
country: 'Argentina',
}, {
coordinates: [-110.53, 60.78],
values: [69, 2.1, 23.7, 0.5, 0.3],
country: 'Canada',
}, {
coordinates: [-100.1, 40.14],
values: [78.3, 0.9, 16.4, 1.2, 1.8],
country: 'United States',
}, {
coordinates: [34.88, 31.16],
values: [2, 18.6, 3.1, 0.3, 75.6],
country: 'Israel',
}].map((data) => {
const list = [`<span class='country'>${data.country}</span>`, ' '];
data.values.forEach((value, i) => {
if (value > 0) {
list.push(`${names[i]}: ${value}%`);
}
});
return {
type: 'Feature',
geometry: {
type: 'Point',
coordinates: data.coordinates,
},
properties: {
tooltip: list.join('\n'),
values: data.values,
},
};
}),
};
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>

Backend API
import React from 'react';
import VectorMap, {
Layer,
Legend,
Source,
Tooltip,
} from 'devextreme-react/vector-map';
import type { ILegendProps, ITooltipProps } from 'devextreme-react/vector-map';
import * as mapsData from 'devextreme-dist/js/vectormap-data/world.js';
import { names, markers } from './data.ts';
const bounds = [-180, 85, 180, -60];
const customizeTooltip: ITooltipProps['customizeTooltip'] = (arg) => {
if (arg.layer.type === 'marker') {
return {
text: arg.attribute('tooltip'),
};
}
return {};
};
const customizeText: ILegendProps['customizeText'] = (arg) => names[arg.index];
export default function App() {
return (
<VectorMap id="vector-map" bounds={bounds}>
<Layer dataSource={mapsData.world} hoverEnabled={false}></Layer>
<Layer
dataSource={markers}
name="pies"
elementType="pie"
dataField="values"
></Layer>
<Tooltip enabled={true} customizeTooltip={customizeTooltip}></Tooltip>
<Legend customizeText={customizeText}>
<Source layer="pies" grouping="color"></Source>
</Legend>
<Tooltip enabled={true} customizeTooltip={customizeTooltip} />
</VectorMap>
);
}
import React from 'react';
import VectorMap, {
Layer, Legend, Source, Tooltip,
} from 'devextreme-react/vector-map';
import * as mapsData from 'devextreme-dist/js/vectormap-data/world.js';
import { names, markers } from './data.js';
const bounds = [-180, 85, 180, -60];
const customizeTooltip = (arg) => {
if (arg.layer.type === 'marker') {
return {
text: arg.attribute('tooltip'),
};
}
return {};
};
const customizeText = (arg) => names[arg.index];
export default function App() {
return (
<VectorMap
id="vector-map"
bounds={bounds}
>
<Layer
dataSource={mapsData.world}
hoverEnabled={false}
></Layer>
<Layer
dataSource={markers}
name="pies"
elementType="pie"
dataField="values"
></Layer>
<Tooltip
enabled={true}
customizeTooltip={customizeTooltip}
></Tooltip>
<Legend customizeText={customizeText}>
<Source
layer="pies"
grouping="color"
></Source>
</Legend>
<Tooltip
enabled={true}
customizeTooltip={customizeTooltip}
/>
</VectorMap>
);
}
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
export const names = ['Christian', 'Muslim', 'Unaffiliated', 'Buddhist', 'Jewish'];
export const markers = {
type: 'FeatureCollection',
features: [{
coordinates: [34.6, -5.1],
values: [61.4, 35.2, 1.4, 0, 0],
country: 'Tanzania',
}, {
coordinates: [18.8, 15],
values: [40.6, 55.3, 2.5, 0, 0],
country: 'Chad',
}, {
coordinates: [7.36, 9.97],
values: [49.3, 48.8, 0.4, 0, 0],
country: 'Nigeria',
}, {
coordinates: [135.61, -24.57],
values: [67.3, 2.4, 24.2, 2.7, 0.5],
country: 'Australia',
}, {
coordinates: [103.3, 34.85],
values: [5.1, 1.8, 52.2, 18.2, 0],
country: 'China',
}, {
coordinates: [139.5, 37],
values: [1.6, 0.2, 57, 36.2, 0],
country: 'Japan',
}, {
coordinates: [100.8, 15.9],
values: [0.9, 5.5, 0.3, 93.2, 0],
country: 'Thailand',
}, {
coordinates: [10.4, 51.4],
values: [68.7, 5.8, 24.7, 0.3, 0.3],
country: 'Germany',
}, {
coordinates: [100.8, 65.3],
values: [73.3, 10, 16.2, 0.1, 0.2],
country: 'Russia',
}, {
coordinates: [-3.48, 40.36],
values: [78.6, 2.1, 19, 0, 0.1],
country: 'Spain',
}, {
coordinates: [-78.01, 21.72],
values: [59.2, 0, 23, 0, 0],
country: 'Cuba',
}, {
coordinates: [-63.7, -31.92],
values: [85.2, 1, 12.2, 0.05, 0.5],
country: 'Argentina',
}, {
coordinates: [-110.53, 60.78],
values: [69, 2.1, 23.7, 0.5, 0.3],
country: 'Canada',
}, {
coordinates: [-100.1, 40.14],
values: [78.3, 0.9, 16.4, 1.2, 1.8],
country: 'United States',
}, {
coordinates: [34.88, 31.16],
values: [2, 18.6, 3.1, 0.3, 75.6],
country: 'Israel',
}].map((data) => {
const list = [`<span class='country'>${data.country}</span>`, ' '];
data.values.forEach((value, i) => {
if (value > 0) {
list.push(`${names[i]}: ${value}%`);
}
});
return {
type: 'Feature',
geometry: {
type: 'Point',
coordinates: data.coordinates,
},
properties: {
tooltip: list.join('\n'),
values: data.values,
},
};
}),
};
declare module 'devextreme-dist/js/vectormap-data/world.js' {
type Position = number[];
type Geometry =
| { type: 'Point'; coordinates: Position }
| { type: 'MultiPoint'; coordinates: Position[] }
| { type: 'LineString'; coordinates: Position[] }
| { type: 'MultiLineString'; coordinates: Position[][] }
| { type: 'Polygon'; coordinates: Position[][] }
| { type: 'MultiPolygon'; coordinates: Position[][][] };
interface Feature {
type: 'Feature';
geometry: Geometry;
properties: Record<string, unknown>;
}
interface FeatureCollection {
type: 'FeatureCollection';
features: Feature[];
// eslint-disable-next-line spellcheck/spell-checker
bbox?: number[];
}
const world: FeatureCollection;
export { world };
export default world;
}
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'*.tsx': {
loader: 'demo-ts-loader',
typescriptOptions: {
jsx: 'react',
},
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'react': {
'esModule': true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'devextreme-dist/js/vectormap-data/*': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
defaultExtension: 'js',
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'devextreme-dist/js/vectormap-data': '../../../../js/vectormap-data',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme-react/common': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
export const names = ['Christian', 'Muslim', 'Unaffiliated', 'Buddhist', 'Jewish'];
export const markers = {
type: 'FeatureCollection',
features: [
{
coordinates: [34.6, -5.1],
values: [61.4, 35.2, 1.4, 0, 0],
country: 'Tanzania',
},
{
coordinates: [18.8, 15],
values: [40.6, 55.3, 2.5, 0, 0],
country: 'Chad',
},
{
coordinates: [7.36, 9.97],
values: [49.3, 48.8, 0.4, 0, 0],
country: 'Nigeria',
},
{
coordinates: [135.61, -24.57],
values: [67.3, 2.4, 24.2, 2.7, 0.5],
country: 'Australia',
},
{
coordinates: [103.3, 34.85],
values: [5.1, 1.8, 52.2, 18.2, 0],
country: 'China',
},
{
coordinates: [139.5, 37],
values: [1.6, 0.2, 57, 36.2, 0],
country: 'Japan',
},
{
coordinates: [100.8, 15.9],
values: [0.9, 5.5, 0.3, 93.2, 0],
country: 'Thailand',
},
{
coordinates: [10.4, 51.4],
values: [68.7, 5.8, 24.7, 0.3, 0.3],
country: 'Germany',
},
{
coordinates: [100.8, 65.3],
values: [73.3, 10, 16.2, 0.1, 0.2],
country: 'Russia',
},
{
coordinates: [-3.48, 40.36],
values: [78.6, 2.1, 19, 0, 0.1],
country: 'Spain',
},
{
coordinates: [-78.01, 21.72],
values: [59.2, 0, 23, 0, 0],
country: 'Cuba',
},
{
coordinates: [-63.7, -31.92],
values: [85.2, 1, 12.2, 0.05, 0.5],
country: 'Argentina',
},
{
coordinates: [-110.53, 60.78],
values: [69, 2.1, 23.7, 0.5, 0.3],
country: 'Canada',
},
{
coordinates: [-100.1, 40.14],
values: [78.3, 0.9, 16.4, 1.2, 1.8],
country: 'United States',
},
{
coordinates: [34.88, 31.16],
values: [2, 18.6, 3.1, 0.3, 75.6],
country: 'Israel',
},
].map((data) => {
const list = [`<span class='country'>${data.country}</span>`, ' '];
data.values.forEach((value, i) => {
if (value > 0) {
list.push(`${names[i]}: ${value}%`);
}
});
return {
type: 'Feature',
geometry: {
type: 'Point',
coordinates: data.coordinates,
},
properties: {
tooltip: list.join('\n'),
values: data.values,
},
};
}),
};
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.tsx");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
#vector-map {
height: 440px;
}